DOCKNOT(1p)

NAME
docknot - Static web site and documentation generator

SYNOPSIS
docknot -h

docknot dist [-d distdir] [-m metadata] [-p pgp-key]

docknot generate [-m metadata] [-w width] template [output]

docknot generate-all [-m metadata] [-w width]

docknot release [-a archivedir] [-d distdir] [-m metadata]

docknot spin [-d] [-e pattern ...] [-s url] source output

docknot spin-rss [-b base] file

docknot spin-text [-lu] [-s url] [-t title] [source [output]]

docknot spin-thread [-f] [-s url] [source [output]]

docknot update [-m metadata] [-o output]

docknot update-spin [path]

DESCRIPTION
docknot is a static web site generator with special support for managing the documentation and releases of software packages. Its actions are organized into subcommands. The supported subcommands are:

dist
    Build, test, and generate a distribution tarball of the package in the current directory. The exact commands used is determined by the package metadata (see App::DocKnot::Config for format documentation).

    After the distribution is built, it will be checked against the source tree and docknot will report an error and exit with a non-zero status if there are any expected files missing.

generate
    Use metadata files and templates to generate human-readable documentation files for a package. See App::DocKnot::Config for documentation on the metadata format, configuration files, and paths.

generate-all
    Like "generate", but generates all of the package documentation for which default output files are configured. This is a quick short-cut to generating all documentation that's shipped with the package.

release
    Copy a distribution tarball into a release area, archiving old versions, and optionally updating configuration for "spin".

spin
    Spin a tree of files written in the macro language thread into an HTML web site. See App::DocKnot::Spin for documentation on the input format and details of the site generation.

spin-rss
    Process a single .rss file with App::DocKnot::Spin::RSS (normally done as part of using "spin" to process a tree of files). See that module's documentation for more details.

spin-text
    Convert a text file to HTML.

spin-thread
    Like "spin", but convert a single file written in thread to HTML.

update
    Update the DocKnot package configuration from an older format.

update-spin
    Update an input tree for "spin" to the latest expectations. This will, for example, convert old-style *.rpod pointer files to new-style *.spin pointer files.

OPTIONS
Each docknot subcommand takes its own options. Many also read global configuration options from DocKnot's configuration. See "Global Configuration" in App::DocKnot::Config for more details.

  Global Options

-h, --help
    Print out usage information and exit.

  dist

-d distdir, --distdir=distdir
    The directory into which to put the generated distribution tarball. This is also used as a working directory for a temporary copy of the package source. This should point to a trusted directory, not one where an attacker could have written files; see "make_distribution()" in App::DocKnot::Dist for more information. Default: The "destdir" option in the global DocKnot configuration file. This option is required if there is no configuration file or if this option is not set.

-m metadata, --metadata=metadata
    The path to the metadata file for the package whose distribution tarball is being generated. Default: docs/docknot.yaml relative to the current directory (which is the recommended metadata path for a project).

-p pgp-key, --pgp-key=pgp-key
    The name of the PGP key to use to sign the generated distribution tarballs. The key can be named in any way that the -u option of GnuPG understands. The generated signature will be armored and stored in a file named by appending ".asc" to the name of the tarball. Default: The "pgp_key" option in the global DocKnot configuration file.

  generate

-m metadata, --metadata=metadata
    The path to the metadata file for the package whose documentation is being generated. Default: docs/docknot.yaml relative to the current directory (which is the recommended metadata path for a project).

-w width, --width=width
    Column width at which the generated output is wrapped. Default: 74.

template
    The template to use when generating the output file.

output
    The path to the output file to generate. If this argument isn't given, the output file will be chosen based on the template as follows:

        readme     ->  README
        readme-md  ->  README.md

    If the template isn't listed above, this argument is required.

  generate-all

-m metadata, --metadata=metadata
    The path to the metadata file for the package whose documentation is being generated. Default: docs/docknot.yaml relative to the current directory (which is the recommended metadata path for a project).

-w width, --width=width
    Column width at which the generated output is wrapped. Default: 74.

  release

-a archivedir, --archivedir=archivedir
    The release area into which to put the distribution tarball. The current distribution will be put in a subdirectory named after the "distribution.section" key in the package configuration. Older versions will be moved to the ARCHIVE subdirectory of archivedir. Default: The "archivedir" option in the global DocKnot configuration file. This option is required if there is no configuration file or if this option is not set.

-d distdir, --distdir=distdir
    The directory from which to get the new distribution tarball, normally generated by "dist". The latest version in this directory will be used. Default: The "destdir" option in the global DocKnot configuration file. This option is required if there is no configuration file or if this option is not set.

-m metadata, --metadata=metadata
    The path to the metadata file for the package whose distribution tarball is being generated. Default: docs/docknot.yaml relative to the current directory (which is the recommended metadata path for a project).

  spin

-d, --delete
    After populating the output tree with the results of converting or copying all the files in the source tree, delete all files and directories in the output tree that do not have a corresponding file in the source tree.

-e pattern, --exclude=pattern
    Exclude files matching the given regular expression pattern from being converted. The pattern is matched only against the file name, not its full path. This flag may be given multiple times.

-s url, --style-url=url
    The base URL for style sheets. All style sheets specified in "\heading" commands will be considered to be relative to this URL and this URL will be prepended to them. If this option is not given, the name of the style sheet will be used verbatim as its URL, except with ".css" appended. This will also be used as the base URL to style sheets for the output of cl2xhtml, cvs2xhtml, and faq2html.

source
    The input tree of files to spin into a web site. This must be a directory.

output
    The output location to write the generated web site. If this directory does not exist, it will be created. If it exists, it must be a directory.

  spin-rss

-b base, --base=base
    By default, output files are relative to the current working directory. If this option is given, output files will be relative to base instead. Output files specified as absolute paths will not be affected.

file
    The .rss file to process. See App::DocKnot::Spin::RSS for the details of the file format.

  spin-text

-m, --modified
    Add a last modified subheading to the converted document based on the last modification timestamp of the source file. This is only done if no RCS/CVS Id string is found in the file. If there is one, it is used in preference. This option is ignored if the input is not a file.

-s style, --style=style
    Use style as the URL of a style sheet for the generated web page. Unless this argument is given, no style sheet will be referred to in the generated web page.

-t title, --title=title
    Use title as the page title rather than whatever may be determined from looking at the input file.

  spin-thread

-s url, --style-url=url
    The base URL for style sheets. A style sheet specified in a "\heading" command will be considered to be relative to this URL and this URL will be prepended to it. If this option is not given, the name of the style sheet will be used verbatim as its URL, except with ".css" appended.

source
    The input file. If not given, standard input will be used.

output
    The output file. If not given, standard output will be used.

  update

-m metadata, --metdata=metadata
    The path to the JSON metadata files for the package that should be converted to the new YAML format. This should be a directory containing all the package metadata files required by App::DocKnot. Default: docs/metadata relative to the current directory.

-o output, --output=output
    The output file for the updated package configuration. Default: docs/docknot.yaml relative to the current directory (which is the recommended metadata path for a project).

  update-spin

path
    The path to the spin input tree to update. If not given, defaults to the current directory.

DIAGNOSTICS
If docknot fails with errors, see the underlying module for that subcommand for information about what those errors might mean. Internally, it can also produce the following diagnostics:

cannot write to %s: %s
    (F) The output file specified with -o could not be written to.

missing required option %s
    (F) One of the required command-line options was not given.

no subcommand given
    (F) No subcommand was given after docknot on the command line.

unknown command %s
    (F) The given subcommand was not recognized.

In addition, other Getopt::Long error messages may result from invalid command-line options.

AUTHOR
Russ Allbery <rra@cpan.org>

COPYRIGHT AND LICENSE
Copyright 2016, 2018-2022 Russ Allbery <rra@cpan.org>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

SEE ALSO
App::DocKnot::Config, App::DocKnot::Dist, App::DocKnot::Generate, App::DocKnot::Spin, App::DocKnot::Spin::RSS, App::DocKnot::Spin::Thread, App::DocKnot::Update

This program is part of the App-DocKnot distribution. The current version of DocKnot is available from CPAN, or directly from its web site at <https://www.eyrie.org/~eagle/software/docknot/>.